# Sub-Unit: Batch computing

Many programs will run just fine on your laptop or through some web interface. However, for large, complex programs that require large amounts of data and take on the order of hours or days to complete, it is better to run the job as a batch through a scheduler.

## Learning Goals

Learn to submit a job to a batch scheduler.

## Resources

https://wiki.cs.earlham.edu/index.php/Getting_started_on_clusters#Using_Slurm

Earlham CS hosts instances of the Slurm scheduler on each of its `cluster.earlham.edu` systems except for Hopper (e.g. Hamilton, Whedon). If you see documents mentioning `qsub` or Torque, they are likely out of date, as we no longer host any Torque instances. Slurm can run some Torque scripts, but it is better to prepare your job to run specifically in Slurm.

How to Connect to Whedon or Hamilton:
You can SSH to these machines by first connecting to Hopper, and then to either Hamilton (`hamilton.cluster.earlham.edu`) or Wheden (`whedon.cluster.earlham.edu`).

## Deliverables

Use the [area under a curve C program](c-examples/auc-trapazoidal-serial.c) provided in this module as the basis for your own program. Compile and run it interactively varying the input until you understand how it scales based on the different parameters. 

Experiment with differnet choices for a, b and n until the job takes about an hour to run on a machine like Hamilton or Whedon. You can time the job by putting `time` in front of your other commands on the command line.

Once you know values to use so that it will take about an hour to run normally, you are ready to move onto the following step.

When you are confident you have proven your program is correct, prepend it with the `time` command and submit it to Slurm using `sbatch`. Run it on Hamilton or Whedon.

Make sure that your submission includes:
* Makefile
* C code
* sbatch script
* the job output

(If you have done the previous subunits correctly, most of these files should "just come along" with your work.)
