import psycopg2
import sys
import matplotlib.pyplot as plt

def main():
	date = []
	temperature = []

#	connectionString = "host='hopper.cluster.earlham.edu' dbname='charliep_db' user='charliep'"
	connectionString = "host='localhost' dbname='charliep' user='charliep'"
 
	print("Connecting to database\n	->%s" % (connectionString))
	connection = psycopg2.connect(connectionString)
	print("Connected!\n")
 
	cursor = connection.cursor()
	sqlStatement = "\
		select record_year::float + (record_month::float/10), mean_month_temp\
		from iceland_stations\
		order by record_year, record_month"
	cursor.execute(sqlStatement)
	print("Selected!")
	
	rows = cursor.fetchall()
	print("Fetched!")
	
	if rows is not None:
		for x in range(0, cursor.rowcount):
			date.append(rows[x][0])
			temperature.append(rows[x][1])

# 	for x in range(0, cursor.rowcount):
# 		print(date[x], temperature[x])
		
	plt.plot(date[:], temperature[:])
	plt.xlabel("Year and Month")
	plt.ylabel("Mean Temperature C")
	plt.title("Monthly mean temperature at Dalatangi, Iceland (Station 620)")
	plt.show()	  

	cursor.close()
	connection.close()
	
if __name__ == "__main__":
	main()
