-- "plain" SQL where binning is arbitrary, with bars
--
-- select trunc(mean_month_temp) as mean,
-- 	lpad('', count(*)::int, '#') as frequency
-- from iceland_stations
-- group by trunc(mean_month_temp)
-- order by trunc(mean_month_temp); 
    

-- SQL standard/Postres width_bucket() function, no bars
-- 
-- select width_bucket(mean_month_temp, -4, 12, 25), count(*), 
-- 	min(mean_month_temp), max(mean_month_temp)
-- from iceland_stations
-- group by 1
-- order by 1; 


-- SQL standard/Postres width_bucket() function, with bars
-- 
select width_bucket(mean_month_temp, -4, 12, 30), count(*), 
	min(mean_month_temp), max(mean_month_temp), lpad('', count(*)::int, '#') as theBar
from iceland_stations
group by 1
order by 1; 

