# System Administration Topical Unit
This unit introduces the most common skills for systems and network administration. This includes commands used to access system configuration information, accessing log and configuration files, tracing the activity of a process, and troubleshoot common user and system issues. There is a heavy emphasis on command-line utilities, including text editors within the terminal. This material also includes cloud technologies like containers and virtual machines which have both become integral to deploying compute resources.

# Learning Goals

* Learn some commonalities of the Linux operating system family.

# Resources

If you haven't been working on the terminal for a while, the CS fundamentals course has a [page about Linux command line utilities](../cs-fundamentals/linux-command-line.md) that you should review. Run some commands to refresh your muscle memory.

We have hosts for Docker containers, a Xen hypervisor where we can spin up a VM for you, and a variety of clusters (a kind of distributed system).

Conditions permitting, you may also be able to visit Turing Lab to learn to provision hardware.

Additional reading:
* [Sysadmin reference guide](https://wiki.cs.earlham.edu/index.php/Sysadmin_reference_guide)
* [Software Carpentry's Unix walkthrough](https://swcarpentry.github.io/shell-novice/) for more shell information

# Deliverables

TBD. Options:

* a bash history file
* a Moodle quiz with some information that can obtained through more advanced system tools e.g. IP address, list of block devices
* host a public-facing webpage on your own virtual server
* a capture of terminal output of all these commands on your VM
* code, probably Bash scripts
